using System;
using System.Collections;
using System.Runtime.InteropServices;
using System.Runtime.InteropServices.ComTypes;
using System.Threading;

namespace Decal.Interop.Input;

internal sealed class IInputBufferEvents_EventProvider : IInputBufferEvents_Event, IDisposable
{
	private IConnectionPointContainer m_ConnectionPointContainer;

	private ArrayList m_aEventSinkHelpers;

	private IConnectionPoint m_ConnectionPoint;

	private void Init()
	{
		IConnectionPoint ppCP = null;
		Guid riid = new Guid(new byte[16]
		{
			230, 89, 205, 4, 46, 103, 166, 69, 174, 10,
			69, 75, 31, 89, 55, 122
		});
		m_ConnectionPointContainer.FindConnectionPoint(ref riid, out ppCP);
		m_ConnectionPoint = ppCP;
		m_aEventSinkHelpers = new ArrayList();
	}

	event IInputBufferEvents_BeginEventHandler IInputBufferEvents_Event.Begin
	{
		add
		{

			bool lockTaken = default(bool);
			try
			{
				Monitor.Enter(this, ref lockTaken);
				if (m_ConnectionPoint == null)
				{
					Init();
				}
				IInputBufferEvents_SinkHelper inputBufferEvents_SinkHelper = new IInputBufferEvents_SinkHelper();
				int pdwCookie = 0;
				m_ConnectionPoint.Advise(inputBufferEvents_SinkHelper, out pdwCookie);
				inputBufferEvents_SinkHelper.m_dwCookie = pdwCookie;
				inputBufferEvents_SinkHelper.m_BeginDelegate = value;
				m_aEventSinkHelpers.Add(inputBufferEvents_SinkHelper);
			}
			finally
			{
				if (lockTaken)
				{
					Monitor.Exit(this);
				}
			}
	
		}
		remove
		{

			bool lockTaken = default(bool);
			try
			{
				Monitor.Enter(this, ref lockTaken);
				if (m_aEventSinkHelpers == null)
				{
					return;
				}
				int count = m_aEventSinkHelpers.Count;
				int num = 0;
				if (0 >= count)
				{
					return;
				}
				do
				{
					IInputBufferEvents_SinkHelper inputBufferEvents_SinkHelper = (IInputBufferEvents_SinkHelper)m_aEventSinkHelpers[num];
					if (inputBufferEvents_SinkHelper.m_BeginDelegate != null && ((inputBufferEvents_SinkHelper.m_BeginDelegate.Equals(value) ? 1u : 0u) & 0xFFu) != 0)
					{
						m_aEventSinkHelpers.RemoveAt(num);
						m_ConnectionPoint.Unadvise(inputBufferEvents_SinkHelper.m_dwCookie);
						if (count <= 1)
						{
							Marshal.ReleaseComObject(m_ConnectionPoint);
							m_ConnectionPoint = null;
							m_aEventSinkHelpers = null;
						}
						break;
					}
					num++;
				}
				while (num < count);
			}
			finally
			{
				if (lockTaken)
				{
					Monitor.Exit(this);
				}
			}
	
		}
	}

	event IInputBufferEvents_EndEventHandler IInputBufferEvents_Event.End
	{
		add
		{

			bool lockTaken = default(bool);
			try
			{
				Monitor.Enter(this, ref lockTaken);
				if (m_ConnectionPoint == null)
				{
					Init();
				}
				IInputBufferEvents_SinkHelper inputBufferEvents_SinkHelper = new IInputBufferEvents_SinkHelper();
				int pdwCookie = 0;
				m_ConnectionPoint.Advise(inputBufferEvents_SinkHelper, out pdwCookie);
				inputBufferEvents_SinkHelper.m_dwCookie = pdwCookie;
				inputBufferEvents_SinkHelper.m_EndDelegate = value;
				m_aEventSinkHelpers.Add(inputBufferEvents_SinkHelper);
			}
			finally
			{
				if (lockTaken)
				{
					Monitor.Exit(this);
				}
			}
	
		}
		remove
		{

			bool lockTaken = default(bool);
			try
			{
				Monitor.Enter(this, ref lockTaken);
				if (m_aEventSinkHelpers == null)
				{
					return;
				}
				int count = m_aEventSinkHelpers.Count;
				int num = 0;
				if (0 >= count)
				{
					return;
				}
				do
				{
					IInputBufferEvents_SinkHelper inputBufferEvents_SinkHelper = (IInputBufferEvents_SinkHelper)m_aEventSinkHelpers[num];
					if (inputBufferEvents_SinkHelper.m_EndDelegate != null && ((inputBufferEvents_SinkHelper.m_EndDelegate.Equals(value) ? 1u : 0u) & 0xFFu) != 0)
					{
						m_aEventSinkHelpers.RemoveAt(num);
						m_ConnectionPoint.Unadvise(inputBufferEvents_SinkHelper.m_dwCookie);
						if (count <= 1)
						{
							Marshal.ReleaseComObject(m_ConnectionPoint);
							m_ConnectionPoint = null;
							m_aEventSinkHelpers = null;
						}
						break;
					}
					num++;
				}
				while (num < count);
			}
			finally
			{
				if (lockTaken)
				{
					Monitor.Exit(this);
				}
			}
	
		}
	}

	event IInputBufferEvents_EventEventHandler IInputBufferEvents_Event.Event
	{
		add
		{

			bool lockTaken = default(bool);
			try
			{
				Monitor.Enter(this, ref lockTaken);
				if (m_ConnectionPoint == null)
				{
					Init();
				}
				IInputBufferEvents_SinkHelper inputBufferEvents_SinkHelper = new IInputBufferEvents_SinkHelper();
				int pdwCookie = 0;
				m_ConnectionPoint.Advise(inputBufferEvents_SinkHelper, out pdwCookie);
				inputBufferEvents_SinkHelper.m_dwCookie = pdwCookie;
				inputBufferEvents_SinkHelper.m_EventDelegate = value;
				m_aEventSinkHelpers.Add(inputBufferEvents_SinkHelper);
			}
			finally
			{
				if (lockTaken)
				{
					Monitor.Exit(this);
				}
			}
	
		}
		remove
		{

			bool lockTaken = default(bool);
			try
			{
				Monitor.Enter(this, ref lockTaken);
				if (m_aEventSinkHelpers == null)
				{
					return;
				}
				int count = m_aEventSinkHelpers.Count;
				int num = 0;
				if (0 >= count)
				{
					return;
				}
				do
				{
					IInputBufferEvents_SinkHelper inputBufferEvents_SinkHelper = (IInputBufferEvents_SinkHelper)m_aEventSinkHelpers[num];
					if (inputBufferEvents_SinkHelper.m_EventDelegate != null && ((inputBufferEvents_SinkHelper.m_EventDelegate.Equals(value) ? 1u : 0u) & 0xFFu) != 0)
					{
						m_aEventSinkHelpers.RemoveAt(num);
						m_ConnectionPoint.Unadvise(inputBufferEvents_SinkHelper.m_dwCookie);
						if (count <= 1)
						{
							Marshal.ReleaseComObject(m_ConnectionPoint);
							m_ConnectionPoint = null;
							m_aEventSinkHelpers = null;
						}
						break;
					}
					num++;
				}
				while (num < count);
			}
			finally
			{
				if (lockTaken)
				{
					Monitor.Exit(this);
				}
			}
	
		}
	}

	public IInputBufferEvents_EventProvider(object P_0)
	{
		//Error decoding local variables: Signature type sequence must have at least one element.
		m_ConnectionPointContainer = (IConnectionPointContainer)P_0;
	}

	public void Finalize()
	{
		bool lockTaken = default(bool);
		try
		{
			Monitor.Enter(this, ref lockTaken);
			if (m_ConnectionPoint == null)
			{
				return;
			}
			int count = m_aEventSinkHelpers.Count;
			int num = 0;
			if (0 < count)
			{
				do
				{
					IInputBufferEvents_SinkHelper inputBufferEvents_SinkHelper = (IInputBufferEvents_SinkHelper)m_aEventSinkHelpers[num];
					m_ConnectionPoint.Unadvise(inputBufferEvents_SinkHelper.m_dwCookie);
					num++;
				}
				while (num < count);
			}
			Marshal.ReleaseComObject(m_ConnectionPoint);
		}
		catch (Exception)
		{
		}
		finally
		{
			if (lockTaken)
			{
				Monitor.Exit(this);
			}
		}
	}

	public void Dispose()
	{
		//Error decoding local variables: Signature type sequence must have at least one element.
		Finalize();
		GC.SuppressFinalize(this);
	}
}
